<HTML>
  <HEAD>
    <TITLE>Galerie</TITLE>
  </HEAD>
  <BODY>
    <?php
    
    function resize($infile, $maxwidth, $maxheight, $outfile, $ctype='image/jpeg')  {  
      // Get original dimensions
      list($width_orig, $height_orig) = getimagesize($infile);
      
      $ratio_orig = $width_orig/$height_orig;
      
      // Get new dimensions
      if ($maxwidth/$maxheight > $ratio_orig) {
         $width = $maxheight*$ratio_orig;
         $height = $maxheight;
      } else {
         $height = $maxwidth/$ratio_orig;
         $width = $maxwidth;
      }
      
      // DEBUG
      //echo($width.'x'.$height.' - ');
      
      // Resample
      $image_p = imagecreatetruecolor($maxwidth, $maxheight);
      $image = imagecreatefromjpeg($infile);
      imagecopyresampled($image_p, $image, 0, 0, 0, 0, $width, $height, $width_orig, $height_orig);
      
      // Output
      imagejpeg($image_p, $outfile, 100);
    }
    
    // Vorabklrungen
    if(gd_info())
    {
      $gd_available=true;
    }
    else  {
      $gd_available=false;
    }
    
    // Ausgabe-Arrays
    $page=array();
    $grid=array();
    $row=array();
    $filedata=array();
    
    if (isset($_REQUEST{'dir'})) {
      $dir=$_REQUEST{'dir'};
    }
    else  {
      $dir=getcwd().'/';
    }
    
    if (isset($_REQUEST{'maxrows'})) {
      $maxrows=$_REQUEST{'maxrows'};
    }
    else  {
      $maxrows=3;
    }
    
    if (isset($_REQUEST{'maxcols'})) {
      $maxcols=$_REQUEST{'maxcols'};
    }
    else  {
      $maxcols=4;
    }
    
    if (isset($_REQUEST{'width'})) {
      $width=$_REQUEST{'width'};
    }
    else  {
      $width=100;
    }
    
    if (isset($_REQUEST{'height'})) {
      $height=$_REQUEST{'height'};
    }
    else  {
      $height=100;
    }
    
    if (isset($_REQUEST{'target'})) {
      $target=$_REQUEST{'target'};
    }
    else  {
      $target='_blank';
    }
    
    if (isset($_REQUEST{'imagetype'})) {
      $imagetype=$_REQUEST{'imagetype'};
    }
    else  {
      $imagetype='.jpg';
    }

    if (isset($_REQUEST{'rebuild'})) {
      $rebuild=$_REQUEST{'rebuild'};
    }
    else  {
      // auto = nur wenn es keine Thumbnails gibt
      // no = nie (wieso auch immer...)
      // force = immer.
      // Der Rest hat keine wirkliche Wirkung
      $rebuild='auto';
    }

    // Open a known directory, and proceed to read its contents
    if (is_dir($dir)) {
        if ($dh = opendir($dir)) {
            while (($file = readdir($dh)) !== false) {
              if (strstr(strtolower($file),$imagetype) && !strstr($file,'tn_'))
                {
                  // DEBUG
                  //echo '<a href="'.$file.'" target="'.$target.'"><img src="'.$file.'" width="'.$width.'" /></a>';
                  if ($gd_available && $rebuild != 'no')  {
                    if ($rebuild == 'auto' && !file_exists($dir.'tn_'.$file) || $rebuild == 'force') {
                      // thumbnail erzeugen
                      resize($dir.$file,$width,$height,$dir.'tn_'.$file );
                    }
                  }
    
                  // File in Zeile
                  $filedata = array('small' => 'tn_'.$file, 'original' => $file, 'target' => $target);
                  array_push($row,$filedata);
                  if (count($row) >= $maxcols)  {
                    // Zeile in Tabelle
                    array_push($grid,$row);
                    $row = array();
                    if (count($grid) >= $maxrows) {
                      // Tabelle auf Seite
                      array_push($page,$grid);
                      $grid = array();
                    }
                  }
                }
            }
            // Unvollstndige Zeile noch anfgen
            if (count($row)>0)  {
              array_push($grid,$row);
              $row = array();
            }
            if (count($grid)>0)  {
              array_push($page,$grid);
              $grid = array();
            }
            closedir($dh);
        }
    }
    
    // DEBUG
    //echo('<PRE>');
    //print_r(array_values($page));
    //echo('</PRE>');
    
    // Ausgabe
    foreach($page as $key => $grid){
      ?>
        Seite <?echo($key)?>
        <table border=1>
        <?
          foreach($grid as $key => $row){
            ?>
              <tr>
                <?
                  foreach($row as $key => $cell){
                    ?>
                      <td>
                        <a href="<?echo($cell{'original'})?>" target="<?echo($cell{'target'})?>"><img src="<?echo($cell{'small'})?>" /></a>
                      </td>
                    <?
                  }
                ?>
              </tr>
            <?
          }
        ?>
        </table>
      <?
    }    
    ?>
  </BODY>
</HTML>